using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Messaging;

namespace MSMQService
{
  public partial class Service : Form
  {
    public Service()
    {
      InitializeComponent();
    }

    private void btnListen_Click(object sender, EventArgs e)
    {
      try
      {
        string Path = txtPath.Text.Trim ();
        if (!System.Messaging.MessageQueue.Exists(Path))
        {
          MessageBox.Show("Ϣв");
          txtPath.SelectAll();
          return;
        }
        this.listView1.Items.Clear();
          

        System.Messaging.MessageQueue MyQueue = new System.Messaging.MessageQueue(Path);
        MyQueue .Formatter =new XmlMessageFormatter (new Type []{typeof (Model .Order)});
        MyQueue.ReceiveCompleted += new ReceiveCompletedEventHandler(MyReceiveCompleted);
        MyQueue.BeginReceive();

        //if (MyQueue.CanRead)
        //{
        //    MessageBox.Show("1");
        //}
        //else
        //{
        //    MessageBox.Show("0");
        //}
      }
      catch (Exception ex)
      {
        MessageBox.Show(ex.Message);
      }
    }
    private  void MyReceiveCompleted(Object source, ReceiveCompletedEventArgs asyncResult)
    {
      try
      {
				MessageQueue mq = (MessageQueue)source;
				System.Messaging .Message ms = mq.EndReceive(asyncResult.AsyncResult);
        listView1.Invoke(new EventHandler(Event), new object[] { ms.Body, EventArgs.Empty });
       
       
				mq.BeginReceive();
			}
			catch(MessageQueueException ex)
			{
        MessageBox.Show(ex.Message);
			}
			return; 
    }
    private void Event(object o, EventArgs e)
    {
      InsertListView((Model .Order )o);
    }
    private  void InsertListView(Model.Order Obj)
    {
      ListViewItem Item = new ListViewItem();
      Item.Text = Obj.Message;
      Item.SubItems.Add(Obj.SendTime.ToString ());
      this.listView1.Items.Insert(0,Item);
    }
  }
}